recognize new archive, audio, image formats; give audio files a separate color
[platform/upstream/coreutils.git] / Makefile.maint
1 # -*-Makefile-*-
2 # This Makefile fragment is shared between the coreutils,
3 # CPPI, Bison, and Autoconf.
4
5 ## Copyright (C) 2001-2006 Free Software Foundation, Inc.
6 ##
7 ## This program is free software; you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation; either version 2, or (at your option)
10 ## any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program; if not, write to the Free Software
19 ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 ## 02110-1301, USA.
21
22 # This is reported not to work with make-3.79.1
23 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 ME := Makefile.maint
25
26 # Do not save the original name or timestamp in the .tar.gz file.
27 # Use --rsyncable if available.
28 gzip_rsyncable := \
29   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
30 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
31
32 CVS = cvs
33 GIT = git
34 VC = $(GIT)
35
36 CVS_LIST = build-aux/vc-list-files
37
38 CVS_LIST_EXCEPT = \
39   $(CVS_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
40
41 ifeq ($(origin prev_version_file), undefined)
42   prev_version_file = .prev-version
43 endif
44
45 PREV_VERSION := $(shell cat $(prev_version_file))
46 VERSION_REGEXP = $(subst .,\.,$(VERSION))
47
48 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
49 tag-this-version = $(subst .,_,$(VERSION))
50 this-vc-tag = $(tag-package)-$(tag-this-version)
51 my_distdir = $(PACKAGE)-$(VERSION)
52
53 # Old releases are stored here.
54 # Used for diffs and xdeltas.
55 release_archive_dir ?= ../release
56
57 # Prevent programs like 'sort' from considering distinct strings to be equal.
58 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
59 export LC_ALL = C
60
61
62
63 ## --------------- ##
64 ## Sanity checks.  ##
65 ## --------------- ##
66
67 # FIXME: add a check to prohibit definition in src/*.c of symbols defined
68 # in system.h.  E.g. today I removed from tail.c a useless definition of
69 # ENOSYS.  It was useless because system.h ensures it's defined.
70
71 # Checks that don't require cvs.
72 # Run `changelog-check' last, as previous test may reveal problems requiring
73 # new ChangeLog entries.
74 local-checks-available = \
75   po-check copyright-check writable-files m4-check author_mark_check \
76   changelog-check patch-check strftime-check $(syntax-check-rules) \
77   makefile_path_separator_check \
78   makefile-check check-AUTHORS
79 .PHONY: $(local-checks-available)
80
81 local-check = $(filter-out $(local-checks-to-skip), $(local-checks-available))
82
83 # Collect the names of rules starting with `sc_'.
84 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
85 .PHONY: $(syntax-check-rules)
86
87 syntax-check: $(syntax-check-rules)
88 #       @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
89 #           $$(find -type f -name '*.[chly]') &&                        \
90 #         { echo '$(ME): found conditional include' 1>&2;               \
91 #           exit 1; } || :
92
93 #       grep -nE '^#  *include <(string|stdlib)\.h>'                    \
94 #           $(srcdir)/{lib,src}/*.[chy] &&                              \
95 #         { echo '$(ME): FIXME' 1>&2;                                   \
96 #           exit 1; } || :
97 # FIXME: don't allow `#include .strings\.h' anywhere
98
99 sc_cast_of_argument_to_free:
100         @grep -nE '\<free \(\(' $(srcdir)/{lib,src}/*.[chly] &&         \
101           { echo '$(ME): don'\''t cast free argument' 1>&2;             \
102             exit 1; } || :
103
104 sc_cast_of_x_alloc_return_value:
105         @grep -nE --exclude=$(srcdir)/lib/xalloc.h                      \
106                 --exclude=$(srcdir)/lib/regex.c                         \
107             '\*\) *x(m|c|re)alloc\>'                                    \
108             $(srcdir)/{lib,src}/*.[chy] &&                              \
109           { echo '$(ME): don'\''t cast x*alloc return value' 1>&2;      \
110             exit 1; } || :
111
112 sc_cast_of_alloca_return_value:
113         @grep -nE '\*\) *alloca\>'                                      \
114             $(srcdir)/src/*.[chy] &&                                    \
115           { echo '$(ME): don'\''t cast alloca return value' 1>&2;       \
116             exit 1; } || :
117
118 sc_space_tab:
119         @grep -n '[ ]   ' $$($(CVS_LIST_EXCEPT)) &&                     \
120           { echo '$(ME): found SPACE-TAB sequence; remove the SPACE'    \
121                 1>&2; exit 1; } || :
122
123 # Don't use the old ato* functions in `real' code.
124 # They provide no error checking mechanism.
125 # Instead, use strto* functions.
126 sc_prohibit_atoi_atof:
127         @grep -nE '\<ato([filq]|ll)\>' $$($(CVS_LIST_EXCEPT)) &&        \
128           { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
129                 1>&2; exit 1; } || :
130
131 # Using EXIT_SUCCESS as the first argument to error is misleading,
132 # since when that parameter is 0, error does not exit.  Use `0' instead.
133 sc_error_exit_success:
134         @grep -nF 'error (EXIT_SUCCESS,'                                        \
135             $$(find -type f -name '*.[chly]') &&                        \
136           { echo '$(ME): found error (EXIT_SUCCESS' 1>&2;               \
137             exit 1; } || :
138
139 sc_file_system:
140         @grep -ni 'file''system' $$($(CVS_LIST_EXCEPT)) &&              \
141           { echo '$(ME): found use of "file''system";'                  \
142             'rewrite to use "file system"' 1>&2;                        \
143             exit 1; } || :
144
145 sc_no_have_config_h:
146         @grep -n 'HAVE''_CONFIG_H' $$($(CVS_LIST_EXCEPT)) &&            \
147           { echo '$(ME): found use of HAVE''_CONFIG_H; remove'          \
148                 1>&2; exit 1; } || :
149
150 # Nearly all .c files must include <config.h>.
151 sc_require_config_h:
152         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
153           grep -L '^# *include <config\.h>'                             \
154                 $$($(CVS_LIST_EXCEPT) | grep '\.c$$')                   \
155               | grep . &&                                               \
156           { echo '$(ME): the above files do not include <config.h>'     \
157                 1>&2; exit 1; } || :;                                   \
158         else :;                                                         \
159         fi
160
161 # Prohibit the inclusion of assert.h without an actual use of assert.
162 sc_prohibit_assert_without_use:
163         @if $(CVS_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then         \
164           files=$$(grep -l '# *include <assert\.h>'                     \
165                     $$($(CVS_LIST_EXCEPT) | grep '\.c$$')) &&           \
166           grep -L '\<assert (' $$files                                  \
167               | grep . &&                                               \
168             { echo "$(ME): the above files include <assert.h> but don't use it" \
169                   1>&2; exit 1; } || :;                                 \
170         else :;                                                         \
171         fi
172
173 sc_obsolete_symbols:
174         @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                     \
175              $$($(CVS_LIST_EXCEPT)) &&                                  \
176           { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY'       \
177                 1>&2; exit 1; } || :
178
179 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
180
181 # Each nonempty line must start with a year number, or a TAB.
182 sc_changelog:
183         @grep -n '^[^12 ]' $$(find . -maxdepth 2 -name ChangeLog) &&    \
184           { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
185             exit 1; } || :
186
187 # Ensure that dd's definition of LONGEST_SYMBOL stays in sync
188 # with the strings from the two affected variables.
189 dd_c = $(srcdir)/src/dd.c
190 sc_dd_max_sym_length:
191 ifneq ($(wildcard $(dd_c)),)
192         @len=$$( (sed -n '/conversions\[\] =$$/,/^};/p' $(dd_c);\
193                  sed -n '/flags\[\] =$$/,/^};/p' $(dd_c) )      \
194                 |sed -n '/"/s/^[^"]*"\([^"]*\)".*/\1/p'         \
195               | wc --max-line-length);                          \
196         max=$$(sed -n '/^#define LONGEST_SYMBOL /s///p' $(dd_c) \
197               |tr -d '"' | wc --max-line-length);               \
198         if test "$$len" = "$$max"; then :; else                 \
199           echo 'dd.c: LONGEST_SYMBOL is not longest' 1>&2;      \
200           exit 1;                                               \
201         fi
202 endif
203
204 # Many m4 macros names once began with `jm_'.
205 # On 2004-04-13, they were all changed to start with gl_ instead.
206 # Make sure that none are inadvertently reintroduced.
207 sc_prohibit_jm_in_m4:
208         @grep -nE 'jm_[A-Z]'                                    \
209                 $$($(CVS_LIST) m4 |grep '\.m4$$'; echo /dev/null) && \
210             { echo '$(ME): do not use jm_ in m4 macro names'    \
211               1>&2; exit 1; } || :
212
213 sc_root_tests:
214         @t1=sc-root.expected; t2=sc-root.actual;                        \
215         grep -nl '^PRIV_CHECK_ARG=require-root'                         \
216           $$($(CVS_LIST) tests) |sed s,tests,., |sort > $$t1;           \
217         sed -n 's,      cd \([^ ]*\) .*MAKE..check TESTS=\(.*\),./\1/\2,p' \
218           $(srcdir)/tests/Makefile.am |sort > $$t2;                     \
219         diff -u $$t1 $$t2 || diff=1;                                    \
220         rm -f $$t1 $$t2;                                                \
221         test "$$diff"                                                   \
222           && { echo 'tests/Makefile.am: missing check-root action'>&2;  \
223                exit 1; } || :
224
225 headers_with_interesting_macro_defs = \
226   exit.h        \
227   fcntl_.h      \
228   fnmatch_.h    \
229   intprops.h    \
230   inttypes_.h   \
231   lchown.h      \
232   openat.h      \
233   stat-macros.h \
234   stdint_.h
235
236 # Create a list of regular expressions matching the names
237 # of macros that are guaranteed by parts of gnulib to be defined.
238 .re-defmac:
239         @(cd $(srcdir)/lib;                                             \
240           for f in $(headers_with_interesting_macro_defs); do           \
241             test -f $$f &&                                              \
242               sed -n '/^# *define \([^_ (][^ (]*\)[ (].*/s//\1/p' $$f;  \
243            done;                                                        \
244          ) | sort -u                                                    \
245            | grep -Ev 'ATTRIBUTE_NORETURN|SIZE_MAX'                     \
246            | sed 's/^/^# *define /'                                     \
247           > $@-t
248         @mv $@-t $@
249
250 # Don't define macros that we already get from gnulib header files.
251 sc_always_defined_macros: .re-defmac
252         @if test -f $(srcdir)/src/system.h; then                        \
253           trap 'rc=$$?; rm -f .re-defmac; exit $$rc' 0 1 2 3 15;        \
254           grep -f .re-defmac $$($(CVS_LIST))                            \
255             && { echo '$(ME): define the above via some gnulib .h file' \
256                   1>&2;  exit 1; } || :;                                \
257         fi
258
259 # Create a list of regular expressions matching the names
260 # of files included from system.h.  Exclude a couple.
261 .re-list:
262         @sed -n '/^# *include /s///p' $(srcdir)/src/system.h \
263           | grep -Ev 'sys/(param|file)\.h' \
264           | sed 's/ .*//;;s/^["<]/^# *include [<"]/;s/\.h[">]$$/\\.h[">]/' \
265           > $@-t
266         @mv $@-t $@
267
268 # Files in src/ should not include directly any of
269 # the headers already included via system.h.
270 sc_system_h_headers: .re-list
271         @if test -f $(srcdir)/src/system.h; then                        \
272           trap 'rc=$$?; rm -f .re-list; exit $$rc' 0 1 2 3 15;          \
273           grep -nE -f .re-list                                          \
274               $$($(CVS_LIST) src |                                      \
275                  grep -Ev '((copy|system)\.h|parse-gram\.c)$$')         \
276             && { echo '$(ME): the above are already included via system.h'\
277                   1>&2;  exit 1; } || :;                                \
278         fi
279
280 sc_sun_os_names:
281         @grep -nEi \
282             'solaris[^[:alnum:]]*2\.(7|8|9|[1-9][0-9])|sunos[^[:alnum:]][6-9]' \
283             $$($(CVS_LIST_EXCEPT)) &&                                   \
284           { echo '$(ME): found misuse of Sun OS version numbers' 1>&2;  \
285             exit 1; } || :
286
287 sc_the_the:
288         @grep -ni '\<the ''the\>' $$($(CVS_LIST_EXCEPT)) &&             \
289           { echo '$(ME): found use of "the ''the";' 1>&2;               \
290             exit 1; } || :
291
292 sc_tight_scope:
293         $(MAKE) -C src $@
294
295 sc_trailing_blank:
296         @grep -n '[      ]$$' $$($(CVS_LIST_EXCEPT)) &&                 \
297           { echo '$(ME): found trailing blank(s)'                       \
298                 1>&2; exit 1; } || :
299
300 # Match lines like the following, but where there is only one space
301 # between the options and the description:
302 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
303 longopt_re = --[a-z][0-9A-Za-z-]*(\[=[0-9A-Za-z-]*\])?
304 sc_two_space_separator_in_usage:
305         @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
306             $$($(CVS_LIST_EXCEPT)) &&                                   \
307           { echo "$(ME): help2man requires at least two spaces between"; \
308             echo "$(ME): an option and its description"; \
309                 1>&2; exit 1; } || :
310
311 # Look for diagnostics that aren't marked for translation.
312 # This won't find any for which error's format string is on a separate line.
313 sc_unmarked_diagnostics:
314         @grep -nE                                                       \
315             '\<error \([^"]*"[^"]*[a-z]{3}' $$($(CVS_LIST_EXCEPT))      \
316           | grep -v '_''(' &&                                           \
317           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
318             exit 1; } || :
319
320 # Avoid useless parentheses like those in this example:
321 # #if defined (SYMBOL) || defined (SYM2)
322 sc_useless_cpp_parens:
323         @grep -n '^# *if .*defined *(' $$($(CVS_LIST_EXCEPT)) &&        \
324           { echo '$(ME): found useless parentheses in cpp directive'    \
325                 1>&2; exit 1; } || :
326
327 # Ensure that the c99-to-c89 patch applies cleanly.
328 patch-check:
329         rm -rf src-c89 $@.1 $@.2
330         cp -a src src-c89
331         (cd src-c89; patch -V never --fuzz=0) < src/c99-to-c89.diff \
332           > $@.1 2>&1
333         grep -v '^patching file ' $@.1 > $@.2 || :
334         if test "$${REGEN_PATCH+set}" = set; then \
335           diff -upr src src-c89 > new-diff || : ; fi
336         fail=0; test -s $@.2 && fail=1 || : ; \
337         rm -f src-c89/*.o || fail=1; \
338         $(MAKE) -C src-c89 CFLAGS='-g -Wdeclaration-after-statement -Werror' \
339           || fail=1; \
340         rm -rf src-c89 $@.1 $@.2; \
341         test $$fail = 0
342
343 # Ensure that date's --help output stays in sync with the info
344 # documentation for GNU strftime.  The only exception is %N,
345 # which date accepts but GNU strftime does not.
346 extract_char = sed 's/^[^%][^%]*%\(.\).*/\1/'
347 strftime-check:
348         if test -f $(srcdir)/src/date.c; then                           \
349           grep '^  %.  ' $(srcdir)/src/date.c | sort                    \
350             | $(extract_char) > $@-src;                                 \
351           { echo N;                                                     \
352             info libc date calendar format | grep '^    `%.'\'          \
353               | $(extract_char); } | sort > $@-info;                    \
354           diff -u $@-src $@-info || exit 1;                             \
355           rm -f $@-src $@-info;                                         \
356         fi
357
358 check-AUTHORS:
359         $(MAKE) -C src $@
360
361 # Ensure that we use only the standard $(VAR) notation,
362 # not @...@ in Makefile.am, now that we can rely on automake
363 # to emit a definition for each substituted variable.
364 makefile-check:
365         grep -nE '@[A-Z_0-9]+@' `find . -name Makefile.am` \
366           && { echo 'Makefile.maint: use $$(...), not @...@' 1>&2; exit 1; } || :
367
368 news-date-check: NEWS
369         today=`date +%Y-%m-%d`; \
370         if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')' \
371             >/dev/null; then \
372           :; \
373         else \
374           echo "version or today's date is not in NEWS" 1>&2; \
375           exit 1; \
376         fi
377
378 changelog-check:
379         if head ChangeLog | grep 'Version $(VERSION_REGEXP)\.$$' \
380             >/dev/null; then \
381           :; \
382         else \
383           echo "$(VERSION) not in ChangeLog" 1>&2; \
384           exit 1; \
385         fi
386
387 m4-check:
388         @grep -n 'AC_DEFUN([^[]' m4/*.m4 \
389           && { echo 'Makefile.maint: quote the first arg to AC_DEFUN' 1>&2; \
390                exit 1; } || :
391
392 # Verify that all source files using _() are listed in po/POTFILES.in.
393 # FIXME: don't hard-code file names below; use a more general mechanism.
394 po-check:
395         if test -f po/POTFILES.in; then                                 \
396           grep -E -v '^(#|$$)' po/POTFILES.in                           \
397             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
398           files=;                                                       \
399           for file in $$($(CVS_LIST_EXCEPT)) lib/*.[ch]; do             \
400             case $$file in                                              \
401             djgpp/* | man/*) continue;;                                 \
402             esac;                                                       \
403             case $$file in                                              \
404             *.[ch])                                                     \
405               base=`expr " $$file" : ' \(.*\)\..'`;                     \
406               { test -f $$base.l || test -f $$base.y; } && continue;;   \
407             esac;                                                       \
408             files="$$files $$file";                                     \
409           done;                                                         \
410           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
411             | sort -u > $@-2;                                           \
412           diff -u $@-1 $@-2 || exit 1;                                  \
413           rm -f $@-1 $@-2;                                              \
414         fi
415
416 # In a definition of #define AUTHORS "... and ..." where the RHS contains
417 # the English word `and', the string must be marked with `N_ (...)' so that
418 # gettext recognizes it as a string requiring translation.
419 author_mark_check:
420         @grep -n '^# *define AUTHORS "[^"]* and ' src/*.c |grep -v ' N_ (' && \
421           { echo 'Makefile.maint: enclose the above strings in N_ (...)' 1>&2; \
422             exit 1; } || :
423
424 # Sometimes it is useful to change the PATH environment variable
425 # in Makefiles.  When doing so, it's better not to use the Unix-centric
426 # path separator of `:', but rather the automake-provided `@PATH_SEPARATOR@'.
427 # It'd be better to use `find -print0 ...|xargs -0 ...', but less portable,
428 # and there probably aren't many projects with so many Makefile.am files
429 # that we'd have to worry about limits on command line length.
430 msg = 'Makefile.maint: Do not use `:'\'' above; use @PATH_SEPARATOR@ instead'
431 makefile_path_separator_check:
432         @grep -n 'PATH=.*:' `find $(srcdir) -name Makefile.am` \
433           && { echo $(msg) 1>&2; exit 1; } || :
434
435 # Check that `make alpha' will not fail at the end of the process.
436 writable-files:
437         if test -d $(release_archive_dir); then :; else                 \
438           mkdir $(release_archive_dir);                                 \
439         fi
440         for file in $(distdir).tar.gz $(xd-delta)                       \
441                     $(release_archive_dir)/$(distdir).tar.gz            \
442                     $(release_archive_dir)/$(xd-delta); do              \
443           test -e $$file || continue;                                   \
444           test -w $$file                                                \
445             || { echo ERROR: $$file is not writable; fail=1; };         \
446         done;                                                           \
447         test "$$fail" && exit 1 || :
448
449 v_etc_file = lib/version-etc.c
450 # Make sure that the copyright date in $(v_etc_file) is up to date.
451 copyright-check:
452         @if test -f $(v_etc_file); then \
453           grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
454             >/dev/null \
455           || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
456                exit 1; }; \
457         fi
458
459
460 # Sanity checks with the repository.
461 # Abort early if this tag has already been used.
462 vc-tag-check:
463         used=no;                                                        \
464         if $(VC) --help | grep CVS; then                                        \
465           $(CVS) -n log -h README|grep -e $(this-vc-tag): >/dev/null    \
466             && used=yes;                                                \
467         else                                                            \
468           $(GIT) tag -l '^$(this-vc-tag)$$' && used=yes;                \
469         fi;                                                             \
470         if test "$$used" = yes; then                                    \
471           echo "$(this-vc-tag) has already been used; not tagging" 1>&2; \
472           exit 1;                                                       \
473         fi
474
475 vc-diff-check:
476         $(VC) diff > vc-diffs || :
477         if test -s vc-diffs; then                               \
478           cat vc-diffs;                                         \
479           echo "Some files are locally modified:" 1>&2;         \
480           exit 1;                                               \
481         else                                                    \
482           rm vc-diffs;                                          \
483         fi
484
485 cvs-check: vc-diff-check vc-tag-check
486
487 maintainer-distcheck:
488         $(MAKE) distcheck
489         $(MAKE) my-distcheck
490
491
492 # Tag before making distribution.  Also, don't make a distribution if
493 # checks fail.  Also, make sure the NEWS file is up-to-date.
494 # FIXME: use dist-hook/my-dist like distcheck-hook/my-distcheck.
495 vc-dist: $(local-check) cvs-check maintainer-distcheck
496         $(VC) tag $(this-vc-tag)
497         $(MAKE) dist
498
499 # Use this to make sure we don't run these programs when building
500 # from a virgin tgz file, below.
501 null_AM_MAKEFLAGS = \
502   ACLOCAL=false \
503   AUTOCONF=false \
504   AUTOMAKE=false \
505   AUTOHEADER=false \
506   MAKEINFO=false
507
508 # Detect format-string/arg-list mismatches that would normally be obscured
509 # by the use of _().  The --disable-nls effectively defines away that macro,
510 # and building with CFLAGS='-Wformat -Werror' causes any format warning to be
511 # treated as a failure.  Also, check for shadowing problems with -Wshadow,
512 # and for pointer arithmetic problems with -Wpointer-arith.
513 # These CFLAGS are pretty strict.  If you build this target, you probably
514 # have to have a recent version of gcc and glibc headers.
515 TMPDIR ?= /tmp
516 t=$(TMPDIR)/$(PACKAGE)/test
517 my-distcheck: $(local-check) $(release_archive_dir)/$(prev-tgz)
518         -rm -rf $(t)
519         mkdir -p $(t)
520         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
521         cd $(t)/$(distdir)                              \
522           && ./configure --disable-nls                  \
523           && $(MAKE) CFLAGS='-Werror -Wall -Wformat -Wshadow -Wpointer-arith' \
524               AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
525           && $(MAKE) dvi                                \
526           && $(MAKE) check                              \
527           && $(MAKE) distclean
528         (cd $(t) && mv $(distdir) $(distdir).old        \
529           && $(AMTAR) -zxf - ) < $(distdir).tar.gz
530         diff -ur $(t)/$(distdir).old $(t)/$(distdir)
531         -rm -rf $(t)
532         @echo "========================"; \
533         echo "$(distdir).tar.gz is ready for distribution"; \
534         echo "========================"
535
536 WGET = wget
537 WGETFLAGS = -C off
538
539 rel-check:
540         tarz=/tmp/rel-check-tarz-$$$$; \
541         md5_tmp=/tmp/rel-check-md5-$$$$; \
542         set -e; \
543         trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
544         $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
545         echo "$(md5)  -" > $$md5_tmp; \
546         md5sum -c $$md5_tmp < $$tarz
547
548 prev-tgz = $(PACKAGE)-$(PREV_VERSION).tar.gz
549 xd-delta = $(PACKAGE)-$(PREV_VERSION)-$(VERSION).xdelta
550
551 rel-files = $(xd-delta) $(DIST_ARCHIVES)
552 announcement: NEWS ChangeLog $(rel-files)
553         @./build-aux/announce-gen                                       \
554             --release-type=$(RELEASE_TYPE)                              \
555             --package=$(PACKAGE)                                        \
556             --prev=$(PREV_VERSION)                                      \
557             --curr=$(VERSION)                                           \
558             --gpg-key-id=$(gpg_key_ID)                                  \
559             --news=NEWS                                                 \
560             $(addprefix --url-dir=, $(url_dir_list))                    \
561
562
563 ## ---------------- ##
564 ## Updating files.  ##
565 ## ---------------- ##
566
567 ftp-gnu = ftp://ftp.gnu.org/gnu
568 www-gnu = http://www.gnu.org
569
570 # Use mv, if you don't have/want move-if-change.
571 move_if_change ?= move-if-change
572
573 emit_upload_commands:
574         @echo =====================================
575         @echo =====================================
576         @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
577         @echo "    --to $(gnu_rel_host):coreutils \\"
578         @echo "  $(rel-files)"
579         @echo '# send the /tmp/announcement e-mail'
580         @echo =====================================
581         @echo =====================================
582
583 $(xd-delta): $(release_archive_dir)/$(prev-tgz) $(distdir).tar.gz
584         xdelta delta -9 $^ $@ || :
585
586 .PHONY: alpha beta major
587 alpha beta major: news-date-check changelog-check $(local-check)
588         test $@ = major                                         \
589           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
590                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
591           || :
592         $(MAKE) vc-dist
593         $(MAKE) $(xd-delta)
594         $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
595         ln $(rel-files) $(release_archive_dir)
596         chmod a-w $(rel-files)
597         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
598         echo $(VERSION) > $(prev_version_file)
599         $(VC) commit -m \
600           '$(prev_version_file): Record previous version: $(VERSION).' \
601           $(prev_version_file)